<template>
  <div :class="{SMSForm : smsFormClass}">
    <div :class="{SMSForm__wrapper : smsFormClass}">
      <div :class="{SMSForm__header : smsFormClass}">
        <h3 :class="{'SMSForm__header-title' : smsFormClass}">
          <slot name="title"></slot>
        </h3>
      </div>
      <div :class="{SMSForm__content : smsFormClass}">
        <div :class="{'prolongation-block-all': prolongation}">
        <!--{{$user.smsSend}}-->

        <p :class="{'SMSForm__content-p' : smsFormClass}">
          <slot name="'additional-title'"></slot>
        </p>

        <div :class="{'SMSForm__content-column' : smsFormClass}" v-if="installment">
          <label class="SMSForm__content-label-title" for="smsCode">Код из СМС</label>
          <div class="SMSForm__content-row">
            <input ref="smsCodeInput"
                   :class="{'SMSForm__content-input' : smsFormClass, 'prolongation-sms-code': prolongation, 'prolongation-sms-code': installment}"
                   type="tel"
                   id="smsCode"
                   autocomplete="off"
                   name="для ввода СМС кода"
                   :placeholder="placeHolder ? '1234' : ''"
                   autofocus
                   v-model="smsCode"
                   v-validate="`required|length:${minCodeLength}`"
                   @keyup.enter="$emit('enter')"
                   v-mask="'####'"
                   class="columns six"
                   v-bind="{guide: true,
                   keepCharPositions: true,}"
            >
            <!--class: [-->
            <!--$interface.viewport === 'desktop' ? 'six': '',-->
            <!--$interface.viewport === 'laptop' ? 'six': '',-->
            <!--getValidateClass('для ввода СМС кода')-->
            <!--],-->
            <slot name="'additional-button'"></slot>
            <button v-if="showButton"
                    class="{SMSForm__content-row-button button blue"
                    :disabled="isSendProhibited || vErrors.has('для ввода СМС кода')"
                    :class="{button_loading: $store.getters.getButtonLoading}"
                    @click="sendCode"
            >Отправить
            </button>
          </div>
        </div>

        <validate-message v-show="vErrors.has('для ввода СМС кода')">
          {{ vErrors.first('для ввода СМС кода') }}
        </validate-message>


        <!--оставить для дороботки-->

        <div class="SMSForm__content-control" v-if="installment">
          <div class="SMSForm__content-control-block">
            <SvgIcon class="SMSForm__content-control-SVG"
                     viewBox="0 0 22 22"
                     xlink="refresh"
                     :class="{'SMSForm__content-control-refresh':loading}"
            />
            <div v-if="resendSmsCallBack"
                 class="SMSForm__content-control-button"
            >
              Выслать код повторно через {{resendSmsBackTime}} {{$helpers.plural(resendSmsBackTime, ['секунду', 'секунды', 'секунд'])}}
            </div>
            <div v-else
                 @click="sendSmsAgain"
                 class="SMSForm__content-control-button"
            >
              Выслать код повторно
            </div>
          </div>
          <slot name="change"></slot>
          <!--<div class="SMSForm__content-control-block" v-if="userSmsSendTotal < maxTotalAttemptCount">-->
          <!--<div class="SMSForm__content-control-block" v-if="changePhone">-->
            <!--<SvgIcon class="SMSForm__content-control-SVG" viewBox="0 0 22 22" xlink="edit-24"/>-->
            <!--<slot name="change">-->
              <!--<div class="SMSForm__content-control-button">Изменить номер телефона</div>-->
            <!--</slot>-->
          <!--</div>-->
        </div>

        <div class="SMSForm__content-warning warning left yellow" v-if="userSmsSendTotal >= maxTotalAttemptCount">
          <div class="warning__wrapper">
            <div class="warning__icon"></div>
            <p class="warning__text">Не получили код в СМС? Обратитесь в <span class="link" @click="">онлайн-чат</span></p>
          </div>
        </div>
        <div class="row" v-if="installment">
          <slot name="agreement"></slot>
        </div>
      </div>
      </div>
    </div>
  </div>
</template>

<script>
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import {errorProlongation} from '@/utils/error/prolongation'
  import SvgIcon from "../SVGIcon/index";
  import smsErrors from '@/utils/error_mapper/smsErrors';

  export default {
    name: "SmsForm",
    mixins: [GetValidateClass],
    components: {
      SvgIcon
    },
    props: {
      resendUrl: {
        type: String,
        required: false,
      },
      changePhone: {
        type: Boolean,
        default: false,
      },
      showButton: {
        type: Boolean,
        default: false,
      },
      value: {
        type: String,
        default: '',
      },
      placeHolder: {
        type: Boolean,
        default: true
      },
      maxPhoneAttemptCount: {
        type: Number,
        default: 3,
      },
      maxTotalAttemptCount: {
        type: Number,
        default: 5,
      },
      sendCodeTimeLimitsMs: {
        type: Number,
        default: /*1000 * 60 * 60*/5000,
      },
      timeOut: {
        type: Number,
        default: 60
      },
      nameError: {
        type: String,
        default: ''
      },
      smsFormClass: {
        type: Boolean,
        default: true
      },
      prolongation: {
        type: Boolean,
        default: false
      },
      installment: {
        type: Boolean,
        default: true
      }
    },
    data() {
      return {
        isAgreementTermsAccepted: true,
        resendSmsCallBack: true,
        resendSmsBackTime: this.timeOut,
        removeRestrictionsTimeout: null,
        smsCode: this.value,
        minCodeLength: 4,
        typeErr: this.nameError,
        loading: false,
      };
    },
    computed: {
      userSmsSend() {
        return this.$user.smsSend;
      },
      userSmsSendPhone() {
        return this.userSmsSend.phone;
      },
      userSmsSendTotal() {
        return this.userSmsSend.total;
      },
      /*достигнут лимит отправки сообщений*/
      isSendLimitReached() {
        return this.userSmsSendPhone >= this.maxPhoneAttemptCount || this.userSmsSendTotal >= this.maxTotalAttemptCount;
      },
      /*отправка запрещена*/
      isSendProhibited() {
        /*если достигнут лимит отправки смс, не принято соглашение, или существует признак загрузки контента с сервера, или длина введённого значения не равна необходимому*/
        return this.isSendLimitReached || !this.isAgreementTermsAccepted || this.$store.getters.getButtonLoading || this.smsCode.length !== this.minCodeLength;
      },
    },
    watch: {
      smsCode () {
        this.$emit('input', this.smsCode) // отслеживаем цифры, которые ввел клиет и передаем их в родительский компонент
        this.$emit('change', this.smsCode) // отслеживаем цифры, которые ввел клиет и передаем их в родительский компонент
      }
    },
    created() {
      /*установка наблюдения за общим количеством импользованных попыток отправки смс*/
      this.$watch('userSmsSend.total', (newValue) => {
        /*если общее количество отправленных смс превышает или равно допустимому*/
        if (this.userSmsSend.total > 2) {
          this.setTimeoutRemoveRestrictions();
        }
      }, {
        immediate: true,
      });
    },
    beforeDestroy() {
      clearTimeout(this.removeRestrictionsTimeout);
    },
    methods: {
        focus () {
            this.$refs.smsCodeInput?.focus();
        },
      async sendCode() {
        this.$emit('change', this.smsCode);
      },
      sendSmsAgain() {
        if (this.resendUrl) {
          this.loading = true;
          this.$backend.getData(this.resendUrl)
            .then(() => {
              this.resendSmsCallBack = true;
              this.countdown();
              this.$toastr.success('Код подтверждения отправлен повторно', 'Успешно');
            })
            .catch((error) => {
              this.$error(error, smsErrors, 'Не удалось отправить смс-код');
            })
            .finally(() => {
              this.loading = false;
            })
        } else {
          this.$emit('resend');
          this.countdown();
        }

      },
      setTimeoutRemoveRestrictions() {
        /*удалить таймаут установленный ранее, если он есть*/
        clearTimeout(this.removeRestrictionsTimeout);
        /*оставшееся время до истечения срока ограничений на отправку смс*/
        const timeRemainingRestrictionsMs = this.userSmsSend.lastSendDateMs + this.sendCodeTimeLimitsMs - new Date;
        console.log('timeRemainingRestrictionsMs:', timeRemainingRestrictionsMs);
        /*если время ограничения отправки смс прошло*/
        if (timeRemainingRestrictionsMs < 0) {
          console.log('timeRemainingRestrictionsMs 1:', timeRemainingRestrictionsMs);
          this.$store.commit('RESET_SENDING_SMS_COUNTER');
          return;
        }
        console.log('timeRemainingRestrictionsMs 2:', timeRemainingRestrictionsMs);
        /*установка ограничения отправки смс на оставшееся время*/
        this.removeRestrictionsTimeout = setTimeout(() => {
            console.log('timeRemainingRestrictionsMs 3:', timeRemainingRestrictionsMs);
            this.$store.commit('RESET_SENDING_SMS_COUNTER');
          },
          timeRemainingRestrictionsMs
        );
      },
      countdown() {
        if (!this.resendSmsBackTime) {
          this.resendSmsCallBack = false
          this.resendSmsBackTime = 60
          return false
        }
        this.resendSmsCallBack = true
        setTimeout(() => {
          this.resendSmsBackTime--
          this.countdown()
        }, 1000)
      },
    },
    mounted () {
      this.smsCode = '';
      this.countdown();
      if (this.$auth.type === 3 && this.$auth.additionalFields?.code !== null) {
        this.smsCode = String(this.$auth.additionalFields?.code);
      }
    }
  }
</script>
